/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.wahlbeteiligung;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.wahlbeteiligung.boundary.AbstractWahlbeteiligungAuswertungSearchParameters;
import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungAuswertungChangeEvent;
import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungAuswertungConversationStore;
import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungAuswertungExtendedDAO;
import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungAuswertungSearch;
import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungAuswertungSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertung;
import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractWahlbeteiligungAuswertungSearchView.COMPONENT_NAME)
@View(viewId = AbstractWahlbeteiligungAuswertungSearchView.VIEW_ID, useCase = UseCasePermission.WAHLBETEILIGUNG_AUSWERTUNG_SEARCH)
public abstract class AbstractWahlbeteiligungAuswertungSearchView extends AbstractElectSearchView<WahlbeteiligungAuswertung> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlbeteiligungAuswertungSearchView";
  
  public static final String VIEW_ID = "/wahlbeteiligung/wahlbeteiligung-auswertung-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractWahlbeteiligungAuswertungSearchView requestHandler;

  @Inject
  private transient WahlbeteiligungAuswertungExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(WahlbeteiligungAuswertungConversationStore.class)
  protected transient WahlbeteiligungAuswertungConversationStore conversationStore;

  @Inject
  protected transient WahlbeteiligungAuswertungSearch search;

  @Inject
  @ConversationGroup(AbstractWahlbeteiligungAuswertungSearchParameters.class)
  protected transient WahlbeteiligungAuswertungSearchParameters searchParameters;

  @Inject
  protected transient WahlbeteiligungAuswertungMeta entityMeta;

  public AbstractWahlbeteiligungAuswertungSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public WahlbeteiligungAuswertung getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(WahlbeteiligungAuswertung entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public WahlbeteiligungAuswertungSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<WahlbeteiligungAuswertung> getEagerLoadingCollector() {
    return EagerLoadingCollector.<WahlbeteiligungAuswertung> create();
  }

  @Override
  public List<WahlbeteiligungAuswertung> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<WahlbeteiligungAuswertung> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onWahlbeteiligungAuswertungChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlbeteiligungAuswertungChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  // elect: Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractWahlbeteiligungAuswertungSearchView {

    @View
    @Inject
    private transient Instance<AbstractWahlbeteiligungAuswertungSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractWahlbeteiligungAuswertungSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
